/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbvtkExtractVtkImageFilter_h_INCLUDED__
#define __bbvtkExtractVtkImageFilter_h_INCLUDED__
#include "bbvtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkVersion.h"


#include <vtkImageData.h>
#include <vtkExtractVOI.h>

namespace bbvtk
{

class bbvtk_EXPORT ExtractVtkImageFilter
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ExtractVtkImageFilter,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
    BBTK_DECLARE_INPUT(In,vtkImageData*);
	BBTK_DECLARE_INPUT(Index,std::vector<int>);
	BBTK_DECLARE_INPUT(Size,std::vector<int>);
	BBTK_DECLARE_OUTPUT(Out,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
	
private:	
	vtkExtractVOI*	_extract;

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ExtractVtkImageFilter,bbtk::AtomicBlackBox);
	BBTK_NAME("ExtractVtkImageFilter");
	BBTK_AUTHOR("Info-Dev Creatis");
	BBTK_DESCRIPTION("crop vtkImageData");
	BBTK_CATEGORY("filter");
	BBTK_INPUT(ExtractVtkImageFilter,In,"Input image",vtkImageData*,"");
	BBTK_INPUT(ExtractVtkImageFilter,Index,"Index (start point of the region to be extracted)",std::vector<int>,"");
	BBTK_INPUT(ExtractVtkImageFilter,Size,"Size of the region to be extracted",std::vector<int>,"");
	BBTK_OUTPUT(ExtractVtkImageFilter,Out,"Output image",vtkImageData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(ExtractVtkImageFilter);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbvtk

#endif // __bbvtkExtractVtkImageFilter_h_INCLUDED__

